/** Concept each channel can have child channels ??**/

const chs = ':'; // Channel separator

class EventualChannel {

	constructor(eventual, name,parent) {
		// We could fetch eventual from parent
		this.eventual = eventual;
		this.name = name;
		this.parent = parent; //?? we need
		
		this.childs = {}
		this.listeners = [];
	}
	// createChannel based on name
	//
	fullName() {
		var name = this.name;
		for(var cur = this;cur = cur.parent;cur.parent) {
			if(this.parent.parent) { // if not root
				name = this.parent.name +":" + name;
			}
		}
		return  name;
	}

	// Recursive
	get2(name,create) {
		if(name == undefined) return this;

		var cur = this;	
		var [childName,...sub] = name.split(chs);
		
		if(cur.child[childName] == undefined) {
			if(!create) return null;
			cur.child[name] = new EventualChannel(this.eventual,name,this);
		}
		return this.get2(sub.join(chs),create);
	};

	// Should be private function
	get(name,create) {
		var nodes = name.split(chs);
		var cur = this;
		var ok = 1;

		nodes.some((v) => {
			if( cur.childs[v] == undefined) {
				if(create == undefined) { cur = null; return true; }
				cur.childs[v] = new EventualChannel(this.eventual,name,this);
			}
			cur = cur.childs[v]; // next;
		});

		return cur;
	}

	channel(name) { // Will create channel and return new child channel
		return this.get(name,true);
	}
	
	// Get listeners
/*	search(name,create) {
		var channel	= this.get(name,create);
		if(channel) return channel.listeners;
		return [];
	}*/

	// Maybe this should be in context?
	// Registers 
	// new listener
	on (name,cb,order) {
		var channel = this.channel(name);
		var listener = { name:name, callback:cb, order: order || 0 };
		channel.listeners.push(listener)

		// Check for state call // Disable this flavouring watch
		var cname = channel.fullName();
		if(this.eventual._events.state[cname]!=undefined) {
			this.eventual.process([listener],this.eventual._events.state[cname]);
		}
		return this;
	}
	
	// Emit is wrong here since it will only call same context
	/*emit(name,args) {
		var tocall = this.search(name);
		return this.eventual.process(tocall,args);
	}*/
}

module.exports = EventualChannel;
