/** Old and deprecated **/
class EventualContext {

	constructor(eventual) {
		this.version = "Context FLAT model";
		this.eventual = eventual;
		// Contextual listeners, it will invalidate regexp?
		this.listeners = [];
	}

	/** flat model **/
	on(name,cb) {
		// Any listener will be placed here
		this.listeners.push({
			name: name,
			callback:cb
		});
		return this;
	}
	getCallbacks(name) {
		var ret = [];
		this.listeners.forEach((l) =>  {
			if(l.name == name) { ret.push(l); }
		})
		return ret;
	}
	emit(name,...args) {
		this.eventual.emit(name,...args);
	}
	/*emit(name,...args) {
		// We need to go trought all contexts in Eventual
		var tocall = [];
		this.eventual._events.ctx.forEach((c) => {
			c.listeners.forEach((l) =>  {
				if(l.name == name) { tocall.push(l); }
			})
		});
		this.eventual.process(tocall,name,args);
	}/**/
	destroy() {
		this.eventual.destroyContext(this);
		this.listeners = null;
	}
}

module.exports = EventualContext;
