var log = require('hlogger').createLogger('memory-monitor');

var activator = {
	start(context) {
		context.events
			.channel('core-shell:cmd')
			.on('memory',(req,res) => {
				if(req.cmd == "start") {
					var itime = time || itime;
					context.setInterval(() => {
						context.call('core-monitor:showStat',res);
					},itime);
				}
			}).on('cache',(req,res)=> {
				if(search) {
					Object.keys(require.cache).forEach((v) => {
						var re = new RegExp(search);
						if(re.test(v)) {
							res.write("Found module: " + v + " parent: " , v.parent );
						}
						var req = require.cache[v];
						if(req.parent && re.test(req.parent.id)	) {
							res.write("Found in parent: " + v + " - " + req.parent.id);
						}
						req.children.forEach((c) => {
							if(re.test(c.id)) {
								res.write("Found on child of: " +v + " - " + c.id);
							}
						});
					});
					return;
				}
			});

	},
	stop(context) {
		clearInterval(this.interval);
	}
}

module.exports.bundleActivator = activator;
